﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.Charting;
using Telerik.WinControls.Paint;
using Telerik.WinControls.UI;

namespace _897930_GridViewChartColumn
{
    public class ChartViewCellElement : GridDataCellElement
    {
        private RadChartElement chartElement;

        public ChartViewCellElement(GridViewColumn column, GridRowElement row) : base(column, row)
        {
        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(GridDataCellElement);
            }
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();

            this.ClipDrawing = true;
            this.chartElement = new RadChartElement();
            this.chartElement.View.AreaType = ChartAreaType.Pie;
            this.chartElement.View.Margin = new System.Windows.Forms.Padding(0);

            this.Children.Add(this.chartElement);
        }

        protected override void SetContentCore(object value)
        {
            if (this.Value != null && this.Value != DBNull.Value)
            {
                var data = value as List<int>;
                this.chartElement.View.Axes.Clear();
                this.chartElement.View.Series.Clear();

                PieSeries series = new PieSeries();
                for (int i = 0; i < data.Count; i++)
                {
                    series.LabelsOffsetFromCenter = 0.5f;
                    series.DataPoints.Add(new PieDataPoint(data[i], "Item" + i));
                    series.ShowLabels = true;
                    this.chartElement.View.Series.Add(series);
                }
            }
        }

        public override bool IsCompatible(GridViewColumn data, object context)
        {
            return data is GridViewChartColumn && context is GridDataRowElement;
        }
    }
}