﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.WinControls.UI;

namespace _897930_GridViewChartColumn
{
    public class MyGridPrintStyle : GridPrintStyle
    {
        protected override BaseGridPrintRenderer InitializePrintRenderer(RadGridView grid)
        {
            if (this.PrintRenderer != null)
            {
                this.PrintRenderer.PrintCellPaint -= renderer_PrintCellPaint;
                this.PrintRenderer.PrintCellFormatting -= renderer_PrintCellFormatting;
                this.PrintRenderer.ChildViewPrinting -= renderer_ChildViewPrinting;
            }

            BaseGridPrintRenderer renderer = null;

            if (grid.ViewDefinition.GetType() == typeof(ColumnGroupsViewDefinition))
            {
                if (!(renderer is ColumnGroupsViewDefinitionPrintRenderer))
                {
                    renderer = new ColumnGroupsViewDefinitionPrintRenderer(grid);
                }
            }
            else if (grid.ViewDefinition.GetType() == typeof(HtmlViewDefinition))
            {
                if (!(renderer is HtmlViewDefinitionPrintRenderer))
                {
                    renderer = new HtmlViewDefinitionPrintRenderer(grid);
                }
            }
            else
            {
                if (!(renderer is TableViewDefinitionPrintRenderer))
                {
                    renderer = new MyTableViewDefinitionPrintRenderer(grid);
                }
            }
            renderer.ChildViewPrinting += renderer_ChildViewPrinting;
            renderer.PrintCellFormatting += renderer_PrintCellFormatting;
            renderer.PrintCellPaint += renderer_PrintCellPaint;

            return renderer;
        }

        private void renderer_PrintCellPaint(object sender, PrintCellPaintEventArgs e)
        {
            this.OnPrintCellPaint(sender, e);
        }

        private void renderer_PrintCellFormatting(object sender, PrintCellFormattingEventArgs e)
        {
            this.OnPrintCellFormatting(sender, e);
        }

        private void renderer_ChildViewPrinting(object sender, ChildViewPrintingEventArgs e)
        {
            this.OnChildViewPrinting(sender, e);
        }
    }
}
